import java.applet.*;
import java.awt.*;
import java.math.*;
import java.util.*;

public class Tomography extends Applet {
  Panel pMainTopPanel,pMainBottomPanel,pLeftPanel,pMidPanel,
  pRightPanel,pTopPanel,pMemoPanel,pPicture1,pPicture2;
  Button BVPButton,CycleButton,ParametersButton,CleanButton,
   SolutionButton,MedianButton,AverageButton,InterpolationButton,CorrectButton,
   MapImageButton,LineImageButton;
  Label HLabel,V0Label,AzLabel,AxLabel,AyLabel,GlobalLabel,LocalLabel,
   WLabel,WxLabel,WyLabel,WzLabel,XcLabel,YcLabel,ZcLabel,ProjectionLabel,
    RadiusLabel,PointsLabel,QuantityLabel,StopLabel,HelpLabel,
    PointsInterpolationLabel,GainLabel,ScaleLabel,VoidLabel1,VoidLabel2;
  TextField HEdit, V0Edit,AzEdit,AxEdit,AyEdit,
   WEdit,WxEdit,WyEdit,WzEdit,XcEdit,YcEdit,ZcEdit,ProjectionEdit,
    RadiusEdit,PointsEdit,QuantityEdit,PointsInterpolationEdit;
  Choice Gain,Scale,Destination;
  TextArea RichEdit1;
  static Graphics gPicture1,gPicture2;
  Dimension Dim1,Dim2;

  static int NetSize=100;
  static int KoefSize=500;

  double X0,Y0,Z0,Fi,Beta,Gamma,X1,Y1,Z1,PI,V0;
  double A_Z,B_X,C_Y,ZMAX=0,T,H=0;
  double v_global,v_local,w,wx,wy,wz,xc,yc,zc;
  double[][] MATRIX = new double[NetSize][NetSize];
  double[] NetX =  new double[NetSize+1];
  double[] NetY =  new double[NetSize+1];
  double[][] KOEF_A = new double[KoefSize][KoefSize];
  double[] KOEF_U =  new double[KoefSize];
  int N_MATRIX=10;
  int N_SOURCE=10;
  int N_PROJ=0;
  double DANGLEP=3;
  int IPIX=1,INEODN=1;
  int CLUE=0;
  double Radius=0,R_SETKA,FI_PROJ;
  int count=0;
  int ESCAPE=0;
  int index_tek=0;
  int index_tek_koef=0;
  int index_tek_a=0;
  int index=0;
  //double Edit1Text,Edit2Text,Edit3Text,Edit4Text,Edit5Text,Edit6Text;
  int pic1X,pic1Y,pic2X,pic2Y;
  //  2:
  double[] x=new double [KoefSize];
  double[] u=new double [KoefSize];
  double[] v=new double [KoefSize];
  double[] w2=new double [KoefSize];
  double[] p_x=new double [KoefSize];
  double[] p_u=new double [KoefSize];
  double[] p_v=new double [KoefSize];
  double[] p_w=new double [KoefSize];
  double[][] A = new double[KoefSize][KoefSize];
  double[][] SOLUTION = new double[NetSize][NetSize];
  double[][] Veloc = new double[NetSize][NetSize];
  double[][] Gladim_Veloc = new double[NetSize][NetSize];
  double[][] Interp_Veloc = new double[NetSize][NetSize];
  double V_DEFECT;
  double s_n;
  int m,n,itmax;
  int N,N_Source,N_Proj;
  int centr,pos,interval; // -2
  String dest;

  public String getAppletInfo() {
   return "Tomography Java Applet. Kislenko N.P., kis@sibstrin.ru";
  }

 public void init() {
  setLayout (new GridLayout(2,1,2,2));
  pMainTopPanel = new Panel();
  pMainTopPanel.setLayout(new GridLayout(1,3,2,2));
  pMainBottomPanel = new Panel();
  pMainBottomPanel.setLayout(new GridLayout(1,2,2,2));
  add (pMainTopPanel);
  add (pMainBottomPanel);

  pLeftPanel = new Panel();
  pMidPanel = new Panel();
  pRightPanel = new Panel();
  pMainTopPanel.add(pLeftPanel);
  pMainTopPanel.add(pMidPanel);
  pMainTopPanel.add(pRightPanel);
  //pLeftPanel.setSize (245,490);
  pLeftPanel.setBackground(Color.white);
  pLeftPanel.setForeground(Color.black);
  //pMidPanel.setSize (245,490);
  pMidPanel.setBackground(Color.white);
  pMidPanel.setForeground(Color.black);
  //pRightPanel.setSize (395,490);
  pRightPanel.setBackground(Color.white);
  pRightPanel.setForeground(Color.black);

  pTopPanel = new Panel();
  pMemoPanel = new Panel();
  pMidPanel.setLayout (new GridLayout (2,1,2,2));
  pMidPanel.add(pTopPanel);
  pMidPanel.add(pMemoPanel);
  RichEdit1=new TextArea ("",10,32);
  pMemoPanel.add (RichEdit1);

  pLeftPanel.setLayout (new GridLayout (14,2,2,2));
  HLabel=new Label ("H"); HEdit=new TextField ("0.001",6);
  GlobalLabel=new Label ("Global"); VoidLabel1=new Label (" ");
  V0Label=new Label ("V0"); V0Edit=new TextField ("1",6);
  AzLabel=new Label ("Az"); AzEdit=new TextField ("0.5",6);
  AxLabel=new Label ("Ax"); AxEdit=new TextField ("0",6);
  AyLabel=new Label ("Ay"); AyEdit=new TextField ("0",6);
  LocalLabel=new Label ("Local"); VoidLabel2=new Label (" ");
  WLabel=new Label ("W"); WEdit=new TextField ("0.1",6);
  WxLabel=new Label ("Wx"); WxEdit=new TextField ("3",6);
  WyLabel=new Label ("Wy"); WyEdit=new TextField ("3",6);
  WzLabel=new Label ("Wz"); WzEdit=new TextField ("10",6);
  XcLabel=new Label ("Xc"); XcEdit=new TextField ("0.1",6);
  YcLabel=new Label ("Yc"); YcEdit=new TextField ("0.05",6);
  ZcLabel=new Label ("Zc"); ZcEdit=new TextField ("0.2",6);

  pLeftPanel.add (HLabel);  pLeftPanel.add (HEdit);
  pLeftPanel.add (GlobalLabel);  pLeftPanel.add (VoidLabel1);
  pLeftPanel.add (V0Label);  pLeftPanel.add (V0Edit);
  pLeftPanel.add (AzLabel);  pLeftPanel.add (AzEdit);
  pLeftPanel.add (AxLabel);  pLeftPanel.add (AxEdit);
  pLeftPanel.add (AyLabel);  pLeftPanel.add (AyEdit);
  pLeftPanel.add (LocalLabel);  pLeftPanel.add (VoidLabel2);
  pLeftPanel.add (WLabel);  pLeftPanel.add (WEdit);
  pLeftPanel.add (WxLabel);  pLeftPanel.add (WxEdit);
  pLeftPanel.add (WyLabel);  pLeftPanel.add (WyEdit);
  pLeftPanel.add (WzLabel);  pLeftPanel.add (WzEdit);
  pLeftPanel.add (XcLabel);  pLeftPanel.add (XcEdit);
  pLeftPanel.add (YcLabel);  pLeftPanel.add (YcEdit);
  pLeftPanel.add (ZcLabel);  pLeftPanel.add (ZcEdit);

  pTopPanel.setLayout (new GridLayout (7,2,2,2));
  ProjectionLabel=new Label ("Projection"); ProjectionEdit=new TextField ("0",6);
  RadiusLabel=new Label ("Radius of circle"); RadiusEdit=new TextField ("1",6);
  PointsLabel=new Label ("Points of net"); PointsEdit=new TextField ("10",6);
  QuantityLabel=new Label ("Quantity of sources"); QuantityEdit=new TextField ("10",6);
  BVPButton=new Button ("BVP"); CycleButton=new Button ("Cycle");
  ParametersButton=new Button ("Parameters");   CleanButton=new Button ("Clean");
  StopLabel=new Label (" "); HelpLabel=new Label (" ");

  pTopPanel.add (ProjectionLabel);  pTopPanel.add (ProjectionEdit);
  pTopPanel.add (RadiusLabel);  pTopPanel.add (RadiusEdit);
  pTopPanel.add (PointsLabel);  pTopPanel.add (PointsEdit);
  pTopPanel.add (QuantityLabel);  pTopPanel.add (QuantityEdit);
  pTopPanel.add (BVPButton);  pTopPanel.add (CycleButton);
  pTopPanel.add (ParametersButton);  pTopPanel.add (CleanButton);
  pTopPanel.add (StopLabel);  pTopPanel.add (HelpLabel);

  pRightPanel.setLayout (new GridLayout (14,1,2,2));
  SolutionButton=new Button ("Solution"); MedianButton=new Button ("Median Filter");
  AverageButton=new Button ("Average"); InterpolationButton=new Button ("Interpolation");
  CorrectButton=new Button ("Correct decision");   MapImageButton=new Button ("Map image");
  LineImageButton=new Button ("Line image");
  Destination=new Choice();
  Destination.addItem("In left panel");
  Destination.addItem("In right panel");
  PointsInterpolationLabel=new Label ("Points of Interpolation"); PointsInterpolationEdit=new TextField ("40",6);
  GainLabel=new Label ("Gain");
  Gain = new Choice();
  for (index=0; index<21; index++) Gain.addItem(""+index);
  ScaleLabel=new Label ("Scale");
  Scale = new Choice();
  for (index=1; index<21; index++) Scale.addItem(""+index);

  pRightPanel.add (SolutionButton); pRightPanel.add (MedianButton);
  pRightPanel.add (AverageButton); pRightPanel.add (InterpolationButton);
  pRightPanel.add (CorrectButton); pRightPanel.add (MapImageButton);
  pRightPanel.add (LineImageButton);
  pRightPanel.add (Destination); Destination.select ("In left panel");
  pRightPanel.add (PointsInterpolationLabel); pRightPanel.add (PointsInterpolationEdit);
  pRightPanel.add (GainLabel);   pRightPanel.add (Gain); Gain.select ("10");
  pRightPanel.add (ScaleLabel);   pRightPanel.add (Scale); Scale.select ("3");

  pPicture1  = new Panel();
  pPicture1.setBackground(Color.black);
  pPicture1.setForeground(Color.white);
  pPicture2  = new Panel();
  pPicture2.setBackground(Color.black);
  pPicture2.setForeground(Color.white);
  pMainBottomPanel.add(pPicture1);
  pMainBottomPanel.add(pPicture2);

  gPicture1 = pPicture1.getGraphics();
  gPicture2 = pPicture2.getGraphics();

  repaint();
 }

 public void clearScreen () {
  //gPicture1.clipRect(0, 0, Dim1.width , Dim1.height);
  gPicture1.clearRect(0, 0, Dim1.width - 1, Dim1.height - 1);
  //gPicture1.drawRect(0, 0, Dim1.width - 1, Dim1.height - 1);
  //gPicture2.clipRect(0, 0, Dim1.width, Dim1.height);
  gPicture2.clearRect(0, 0, Dim1.width - 1, Dim1.height - 1);
  //gPicture2.drawRect(0, 0, Dim1.width - 1, Dim1.height - 1);
 }

 public void paint(Graphics g) {
  clearScreen ();
 }

 public void Parameters () {
  int Corrected=0;
  Radius=new Double(RadiusEdit.getText().trim()).doubleValue();
  if(Radius>2) {
   Radius=2; Corrected=1;
   RadiusEdit.setText (""+Radius);
  }
  else if(Radius<0.45) {
   Radius=0.5; Corrected=1;
   RadiusEdit.setText (""+Radius);
  }
  H=new Double(HEdit.getText().trim()).doubleValue();
  if (H<0.0005) {
   H=0.001; Corrected=1;
   HEdit.setText (""+H);
  }
  else if (H>0.01) {
   H=0.01; Corrected=1;
   HEdit.setText (""+H);
  }
  R_SETKA=Radius;
  N_MATRIX=new Integer(PointsEdit.getText().trim()).intValue();
  if(N_MATRIX!=10) {
   N_MATRIX=10; Corrected=1;
   PointsEdit.setText (""+N_MATRIX);
  }
  N_SOURCE=new Integer(QuantityEdit.getText().trim()).intValue();
  if (N_SOURCE!=10) {
   N_SOURCE=10; Corrected=1;
   QuantityEdit.setText (""+N_SOURCE);
  }
  V0=new Double(V0Edit.getText().trim()).doubleValue();
  if(V0!=1){
   V0=1; Corrected=1;
   V0Edit.setText (""+V0);
  }
  A_Z=new Double(AzEdit.getText().trim()).doubleValue();
  if (A_Z>1.) {
   A_Z=0.5; Corrected=1;
   AzEdit.setText (""+A_Z);
  }
  else if(A_Z<0.3) {
   A_Z=0.5; Corrected=1;
   AzEdit.setText (""+A_Z);
  }
  B_X=new Double(AxEdit.getText().trim()).doubleValue();
  if (Math.abs(B_X)>0.05) {
   B_X=0; Corrected=1;
   AxEdit.setText (""+B_X);
  }
  C_Y=new Double(AyEdit.getText().trim()).doubleValue();
  if (Math.abs(C_Y)>0.05) {
   C_Y=0; Corrected=1;
   AyEdit.setText (""+C_Y);
  }
  w=new Double(WEdit.getText().trim()).doubleValue();
  if (Math.abs(w)>0.1) {
   w=0.1; Corrected=1;
   WEdit.setText (""+w);
  }
  wx=new Double(WxEdit.getText().trim()).doubleValue();
  if (wx<0.5) {
   wx=0.5; Corrected=1;
   WxEdit.setText (""+wx);
  }
  wy=new Double(WyEdit.getText().trim()).doubleValue();
  if(wy<0.5) {
   wy=0.5; Corrected=1;
   WyEdit.setText (""+wy);
  }
  wz=new Double(WzEdit.getText().trim()).doubleValue();
  if (wz<0.5) {
   wz=0.5; Corrected=1;
   WzEdit.setText (""+wz);
  }
  xc=new Double(XcEdit.getText().trim()).doubleValue();
  yc=new Double(YcEdit.getText().trim()).doubleValue();
  zc=new Double(ZcEdit.getText().trim()).doubleValue();

  for(int i=0;i<N_MATRIX;i++) {
   NetX[i]=-R_SETKA+(2*R_SETKA/(double)(N_MATRIX-1))*i;
   NetY[i]=-R_SETKA+(2*R_SETKA/(double)(N_MATRIX-1))*i;
  }
  for(int i=0;i<N_MATRIX-1;i++) {
   for(int j=0;j<N_MATRIX-1;j++) {
    MATRIX[i][j]=0;
   }
  }
  if (Corrected!=0) {
   RichEdit1.append ("Parameters was corrected\r\n");
  }
 }

 public void LineTo1 (int xx, int yy) {
  gPicture1.drawLine (pic1X,pic1Y,xx,yy);
  pic1X=xx;
  pic1Y=yy;
 }

 public void LineTo2 (int x2, int y2) {
  gPicture2.drawLine (pic2X,pic2Y,x2,y2);
  pic2X=x2;
  pic2Y=y2;
 }

 public void Runge () {
  double PI,V,Fi,X2,Y2,Z2;//,ZMAX=0; //X0,Y0,Z0,X1,Y1,Z1,T,
  double XS0,YS0,ZS0,XS1,YS1,ZS1,XS2,YS2,ZS2,H1,DX,DY,DZ,DX1,DY1,DZ1;
  double Q1X1,Q1Y1,Q1Z1,Q1X2,Q1Y2,Q1Z2,
         Q2X1,Q2Y1,Q2Z1,Q2X2,Q2Y2,Q2Z2,
         Q3X1,Q3Y1,Q3Z1,Q3X2,Q3Y2,Q3Z2,
         Q4X1,Q4Y1,Q4Z1,Q4X2,Q4Y2,Q4Z2;
  double dlnV_dX,dlnV_dY,dlnV_dZ,Rad;//, V0,A_Z,B_X,C_Y,H;
  int ismenax;
  int iX0,iY0,iZ0,iX1,iY1,iZ1;
  //int count=0;
  ZMAX=0;
  count=0;
  ismenax=-1;
  Radius=new Double(RadiusEdit.getText().trim()).doubleValue();
  PI=2.0*Math.asin(1.0);  Rad=Radius;
  //X0=Edit1Text; Y0=Edit2Text; Z0=Edit3Text; //X0=Form1->X0; Y0=Form1->Y0; Z0=Form1->Z0;
  V0=new Double(V0Edit.getText().trim()).doubleValue();
  if (IPIX==1) {
   for(int i=0;i<N_MATRIX-1;i++) {
    for(int j=0;j<N_MATRIX-1;j++) {
     MATRIX[i][j]=0;
    }
   }
  }
  double fi;
  iX0=(int)((Rad+2)*100); iY0=0;

  pic2X=iX0; pic2Y=iY0+Dim2.height/2; //Bitmap2->Canvas->MoveTo(iX0,iY0+Bitmap2->Height/2);
  for (int i=0;i<=360;i=i+10) {
   fi=i*PI/180.;
   iX1=(int)((Math.cos(fi)*Rad+2)*100);
   iY1=(int)(Math.sin(fi)*Rad*100);
   LineTo2 (iX1,iY1+Dim2.height/2);
  }
  iX0=(int)(100*(X0+2)); iZ0=(int)(100*Z0); iY0=(int)(100*Y0);
  pic1X=(int)(iX0); pic1Y=(int)(iZ0); //Bitmap1->Canvas->MoveTo(iX0,iZ0);
  pic2X=(int)(iX0); pic2Y=(int)(iY0+Dim2.height/2); //Bitmap2->Canvas->MoveTo(iX0,iY0+Bitmap2->Height/2);
//  X1=Edit4Text; Y1=Edit5Text; Z1=Edit6Text; //X1=Form1->X1;Y1=Form1->Y1;Z1=Form1->Z1;

  //A_Z=Tomography.A_Z; B_X=Tomography.B_X; C_Y=Tomography.C_Y;

  T=0; //H=Tomography.H;
  do { //m0:
   H1=H;//Tomography.H;
   if(Z0<0.005) H1= H1/10.0;
   v_global= V0+A_Z*Z0+B_X*X0+C_Y*Y0;
   //------ local:
   if (INEODN==1) {
    v_local= w*Math.exp(-wx*(xc-X0)*(xc-X0)-
             wy*(yc-Y0)*(yc-Y0)-wz*(zc-Z0)*(zc-Z0) );
   }
   if (INEODN==0) {
    v_local= 0 ;
   }
   dlnV_dX=(1.0/(v_global+v_local))*(B_X+v_local*wx*2*(xc-X0));
   dlnV_dY=(1.0/(v_global+v_local))*(C_Y+v_local*wy*2*(yc-Y0));
   dlnV_dZ=(1.0/(v_global+v_local))*(A_Z+v_local*wz*2*(zc-Z0));
   //===========
   X2=X1*(dlnV_dY*Y1+dlnV_dZ*Z1+X1*dlnV_dX)-dlnV_dX;
   Y2=Y1*(dlnV_dX*X1+dlnV_dZ*Z1+Y1*dlnV_dY)-dlnV_dY;
   Z2=Z1*(dlnV_dX*X1+dlnV_dY*Y1+Z1*dlnV_dZ)-dlnV_dZ;
   Q1X1=H1*X1; Q1Y1=H1*Y1; Q1Z1=H1*Z1;
   Q1X2=H1*X2; Q1Y2=H1*Y2; Q1Z2=H1*Z2;
   //-- 1 STEP   Q1..
   XS0=X0+Q1X1/2.0; YS0=Y0+Q1Y1/2.0; ZS0=Z0+Q1Z1/2.0;
   XS1=X1+Q1X2/2.0; YS1=Y1+Q1Y2/2.0; ZS1=Z1+Q1Z2/2.0;
   X2=XS1*(dlnV_dY*YS1+dlnV_dZ*ZS1+XS1*dlnV_dX)-dlnV_dX;
   Y2=YS1*(dlnV_dX*XS1+dlnV_dZ*ZS1+YS1*dlnV_dY)-dlnV_dY;
   Z2=ZS1*(dlnV_dX*XS1+dlnV_dY*YS1+ZS1*dlnV_dZ)-dlnV_dZ;
   Q2X1=H1*XS1; Q2Y1=H1*YS1; Q2Z1=H1*ZS1;
   Q2X2=H1*X2; Q2Y2=H1*Y2; Q2Z2=H1*Z2;
   //-- 2 STEP   Q2..
   XS0=X0+Q2X1/2.0; YS0=Y0+Q2Y1/2.0; ZS0=Z0+Q2Z1/2.0;
   XS1=X1+Q2X2/2.0; YS1=Y1+Q2Y2/2.0; ZS1=Z1+Q2Z2/2.0;
   X2=XS1*(dlnV_dY*YS1+dlnV_dZ*ZS1+XS1*dlnV_dX)-dlnV_dX;
   Y2=YS1*(dlnV_dX*XS1+dlnV_dZ*ZS1+YS1*dlnV_dY)-dlnV_dY;
   Z2=ZS1*(dlnV_dX*XS1+dlnV_dY*YS1+ZS1*dlnV_dZ)-dlnV_dZ;
   Q3X1=H1*XS1; Q3Y1=H1*YS1; Q3Z1=H1*ZS1;
   Q3X2=H1*X2; Q3Y2=H1*Y2; Q3Z2=H1*Z2;
   //-- 3 STEP   Q3..
   XS0=X0+Q3X1; YS0=Y0+Q3Y1; ZS0=Z0+Q3Z1;
   XS1=X1+Q3X2; YS1=Y1+Q3Y2; ZS1=Z1+Q3Z2;
   X2=XS1*(dlnV_dY*YS1+dlnV_dZ*ZS1+XS1*dlnV_dX)-dlnV_dX;
   Y2=YS1*(dlnV_dX*XS1+dlnV_dZ*ZS1+YS1*dlnV_dY)-dlnV_dY;
   Z2=ZS1*(dlnV_dX*XS1+dlnV_dY*YS1+ZS1*dlnV_dZ)-dlnV_dZ;
   Q4X1=H1*XS1; Q4Y1=H1*YS1; Q4Z1=H1*ZS1;
   Q4X2=H1*X2; Q4Y2=H1*Y2; Q4Z2=H1*Z2;
   //-- 4 STEP   Q4..
   DX=(Q1X1+2.0*(Q2X1+Q3X1)+Q4X1)/6.0;
   DY=(Q1Y1+2.0*(Q2Y1+Q3Y1)+Q4Y1)/6.0;
   DZ=(Q1Z1+2.0*(Q2Z1+Q3Z1)+Q4Z1)/6.0;
   DX1=(Q1X2+2.0*(Q2X2+Q3X2)+Q4X2)/6.0;
   DY1=(Q1Y2+2.0*(Q2Y2+Q3Y2)+Q4Y2)/6.0;
   DZ1=(Q1Z2+2.0*(Q2Z2+Q3Z2)+Q4Z2)/6.0;
   X0=X0+DX;
   Y0=Y0+DY;
   Z0=Z0+DZ;
   //-------
   if (INEODN==1) {
    v_local= w*Math.exp(-wx*(xc-(X0+DX/2))*(xc-(X0+DX/2))-
             wy*(yc-(Y0+DY/2))*(yc-(Y0+DY/2))-
             wz*(zc-(Z0+DZ/2))*(zc-(Z0+DZ/2)) );
   }
   if (INEODN==0) { v_local= 0 ; }
   //-------
   v_global= V0+A_Z*(Z0+DZ/2)+B_X*(X0+DX/2.0)+C_Y*(Y0+DY/2.0);
   //---------------------------------
   V=v_global+v_local;
   //------------------------------------
   T+=Math.sqrt(DX*DX+DY*DY+DZ*DZ)/V;
   int imatrx=0,imatry=0,inetx,inety;
   if(IPIX!=0) { //goto PIXOUT;
    for (inetx=0;inetx<N_MATRIX-1;inetx++) {
     if ((X0>=NetX[inetx]) && (X0<NetX[inetx+1])) {
      imatrx=inetx;
      if (ismenax!=imatrx) ismenax=imatrx;
      break;
     }
    }
    for (inety=0;inety<N_MATRIX-1;inety++) {
     if ((Y0>=NetY[inety]) && (Y0<NetY[inety+1])) {
      imatry=inety;
      break;
     }
    }
    MATRIX[imatrx][imatry]=MATRIX[imatrx][imatry]+Math.sqrt(DX*DX+DY*DY+DZ*DZ);
   }
   if (Z0>ZMAX) ZMAX=Z0;
   X1=X1+DX1; Y1=Y1+DY1; Z1=Z1+DZ1;

   //Edit1Text=X0; Edit2Text=Y0; Edit3Text=Z0; //Form1->X0=X0; Form1->Y0=Y0; Form1->Z0=Z0;
   //Edit4Text=X1; Edit5Text=Y1; Edit6Text=Z1; //Form1->X1=X1; Form1->Y1=Y1; Form1->Z1=Z1;
   //Tomography.count=count; Tomography.ZMAX=ZMAX;
   if (Z0<0.0) {
    //Tomography.T=T;
    //  Image1->Picture->Assign(Bitmap1);
    //  Image2->Picture->Assign(Bitmap2);
    return;
   }
   iX0=(int)(100*(X0+2)); iZ0=(int)(400*Z0); iY0=(int)(100*Y0);
   if (count%100==0) {
    LineTo2 (iX0,iY0+Dim2.height/2); //Bitmap2->Canvas->LineTo(iX0,iY0+Bitmap2->Height/2);
    LineTo1 (iX0,iZ0); //Bitmap1->Canvas->LineTo(iX0,iZ0);
   }

   if (ESCAPE==1) break; //Application->ProcessMessages();
   count++;
   if(count<1200000) continue; //goto m0
   else break;
  } while (true);
  //delete(Bitmap1); delete(Bitmap2);
 }

 public double lagr(int N,double[] x,double[] f,double x1) {
  int i,j;
  double a,b,q;
  a=0.;
  for (i=0; i<N; i++) {
   b=1.;
   for(j=0; j<N;j++) {
    if (j==i) continue;
    b=b*(x1-x[j])/(x[i]-x[j]) ;
   }
   a=a+b*f[i];
  }
  q=a; 	return q;
 }

 public void Start () {
//X0=Edit1Text; Y0=Edit2Text; Z0=Edit3Text; X1=Edit4Text; Y1=Edit5Text; Z1=Edit6Text; 
  A_Z=new Double(AzEdit.getText().trim()).doubleValue();
  B_X=new Double(AxEdit.getText().trim()).doubleValue();
  C_Y=new Double(AyEdit.getText().trim()).doubleValue();
  w=new Double(WEdit.getText().trim()).doubleValue();
  wx=new Double(WxEdit.getText().trim()).doubleValue();
  wy=new Double(WyEdit.getText().trim()).doubleValue();
  wz=new Double(WzEdit.getText().trim()).doubleValue();
  xc=new Double(XcEdit.getText().trim()).doubleValue();
  yc=new Double(YcEdit.getText().trim()).doubleValue();
  zc=new Double(ZcEdit.getText().trim()).doubleValue();
  H=new Double(HEdit.getText().trim()).doubleValue();
  double L,R,tx0,ty0,tz0,Z_M,Rad,Test;
  Gamma=Math.acos(Z1);
  R=1.0/(A_Z*Math.sin(Gamma));
  L=2.0*Math.sqrt(R*R-1.0/(A_Z*A_Z));
  Z_M=R-1/A_Z;
  double p=1.00+A_Z*A_Z*L*L/2.00;
  Test=Math.log(p+Math.sqrt(p*p-1.0))/A_Z;
  count=0;
  Runge ();
 }

 public void BVP () {
  double R1,R2=0,Step,Rad,pi,DZ1,Z1d,X1d,Y1d,max,Zsol;
  //FILE *OUT_MATRIX,*OUT_MATRIX_U,*OUT_MATRIX_I;
  int i,j;double acfis;
  N_PROJ++;
  Rad=Radius;
  Step=2*Rad/(double)(N_SOURCE-1);
  pi=2*Math.asin(1.0);
  FI_PROJ=new Double(ProjectionEdit.getText().trim()).doubleValue();
  FI_PROJ*=(pi/180);
  ESCAPE=0;

  double[] P =  new double[N_SOURCE];
  double[] S =  new double[N_SOURCE];
  double[] X0P =  new double[N_SOURCE];
  double[] XP =  new double[N_SOURCE];
  double[] YP =  new double[N_SOURCE];
  double[] XS =  new double[N_SOURCE];
  double[] YS =  new double[N_SOURCE];
  double[] mzs =  new double[N_SOURCE];
  double[] Time =  new double[N_SOURCE];
  double[] FI_SOURCE =  new double[N_SOURCE];
  double[] FI_RESOURCE =  new double[N_SOURCE];
  double[] PY =  new double[3];
  double[] T_PY =  new double[3];
  /*if (CLUE==0) CheckBox1->Checked==false;//to file
  if(CheckBox1->Checked==true)
   OUT_MATRIX=fopen(OpenDialog1->FileName.c_str(),"at");
  if(CheckBox1->Checked==true)
   OUT_MATRIX_U=fopen(OpenDialog2->FileName.c_str(),"at");*/
  Step=Math.abs(NetX[0])-Math.abs(NetX[1]);
  for(i=0;i<N_SOURCE-1;i++) {
   P[i]=-(Rad-Step*i)+Step/2;
   S[i]=Math.sqrt(Rad*Rad-P[i]*P[i]);
   X0P[i]=-Math.sqrt(Rad*Rad-P[i]*P[i]);
   if (P[i]<0) FI_SOURCE[i]= -Math.acos(X0P[i]/Rad);
   else FI_SOURCE[i]=Math.acos(X0P[i]/Rad);
   if (P[i]<0) FI_RESOURCE[i]=-pi-FI_SOURCE[i];
   else FI_RESOURCE[i]=pi-FI_SOURCE[i];
   XP[i]=Rad*Math.cos(FI_SOURCE[i]+FI_PROJ);
   XS[i]=Rad*Math.cos(FI_RESOURCE[i]+FI_PROJ);
   YP[i]=Rad*Math.sin(FI_SOURCE[i]+FI_PROJ);
   YS[i]=Rad*Math.sin(FI_RESOURCE[i]+FI_PROJ);
  }
  int iX0,iY0,iZ0,iX1,iY1,iZ1;
  Radius=new Double(RadiusEdit.getText().trim()).doubleValue();
  PI=2.0*Math.asin(1.0);
  Rad=Radius;
  double fi;

  gPicture2.setColor(Color.green);
  iX0=2*100;
  gPicture2.drawLine (iX0,0,iX0,Dim2.height);
  gPicture2.drawLine (0,Dim2.height/2,Dim2.width,Dim2.height/2);
  gPicture2.setColor(Color.white);

  for (i=0;i<N_SOURCE-1;i++) {
   iX0=(int)((XP[i]+2)*100);
   iY0=(int)(YP[i]*100);
   iX1=(int)((XS[i]+2)*100);
   iY1=(int)(YS[i]*100);
   gPicture2.drawLine (iX0,iY0+Dim2.height/2,iX1,iY1+Dim2.height/2);
  }
  gPicture2.setColor(Color.green);
  for(i=0;i<N_MATRIX;i++) {
   iX0=(int)((NetX[0]+2)*100);
   iY0=(int)(NetY[i]*100);
   iX1=(int)((NetX[N_MATRIX-1]+2)*100);
   gPicture2.drawLine (iX0,iY0+Dim2.height/2,iX1,iY0+Dim2.height/2);
  }
  for(i=0;i<N_MATRIX;i++) {
   iX0=(int)((NetX[i]+2)*100);
   iY0=(int)(NetY[0]*100);
   iY1=(int)(NetY[N_MATRIX-1]*100);
   gPicture2.drawLine (iX0,iY0+Dim2.height/2,iX0,iY1+Dim2.height/2);
  }
  gPicture2.setColor(Color.white);
  //   
  Z0=0;
  DZ1=1/10.;
  double DANGLE;
  DANGLE=DANGLEP*PI/180;
  for(i=0;i<N_SOURCE-1;i++) {
   for(iY1=0;iY1<3;iY1++) {
    gPicture1.setColor(Color.black);
    gPicture1.clearRect (0,0,Dim1.width, Dim1.height);
    gPicture1.setColor(Color.white);
    gPicture1.drawRect (0,0,Dim1.width, Dim1.height);
    DZ1=1/10.;
    j=0;
    Z1d=0.01;
    // START M0:
    do {
     //Application->ProcessMessages();
     if (ESCAPE==1) { return; }
     j++;
     Z1=Z1d;
     Y1= Math.sin(FI_PROJ+(iY1-1)*DANGLE);
     X1= Math.cos(FI_PROJ+(iY1-1)*DANGLE);
     max=Math.sqrt(X1*X1+Z1*Z1+Y1*Y1);
     Y1=Y1/max; Z1=Z1/max; X1=X1/max;
     X0=XP[i]; Y0=YP[i];Z0=0; Zsol=Z1;

//     Edit1Text=X0; Edit2Text=Y0; Edit3Text=Z0;
//     Edit4Text=X1; Edit5Text=Y1; Edit6Text=Z1;
     IPIX=0; INEODN=1;

     Start();

     R1=2*S[i]-Math.sqrt((X0-XP[i])*(X0-XP[i])+(Y0-YP[i])*(Y0-YP[i])) ;

     if (Math.abs(R1)<0.0001) break; //goto M1;

     //-----------------
     X0=XP[i]; Y0=YP[i];Z0=0; Z1=Z1d;
     Y1=Math.sin(FI_PROJ+(iY1-1)*DANGLE);
     X1=Math.cos(FI_PROJ+(iY1-1)*DANGLE);
     Z1=Z1+DZ1;
     max=Math.sqrt(X1*X1+Z1*Z1+Y1*Y1);
     Y1=Y1/max; Z1=Z1/max; X1=X1/max;
//     Edit1Text=X0; Edit2Text=Y0; Edit3Text=Z0;
//     Edit4Text=X1; Edit5Text=Y1; Edit6Text=Z1;
     Zsol=Z1;

     IPIX=0;     INEODN=1;
     Start();
     R2=2*S[i]-Math.sqrt((X0-XP[i])*(X0-XP[i])+(Y0-YP[i])*(Y0-YP[i])) ;
     Z1=Z1d;
     if (R1*R2<0) {  DZ1=DZ1/2.0; }
     if (R1*R2>0) {  Z1d=Z1+DZ1;  }
     if(j>50) break; //goto M1;
     if (Math.abs(R2)>0.0001) continue;
     else break;
    } while (true);
//M1:
    if (Math.abs(R1)<0.0001)
     if(Math.abs(R2)<0.0001)
      if (j>50) RichEdit1.append ("J>50\r\n");
    T_PY[iY1]=T;
    PY[iY1]=-X0*Math.sin(FI_PROJ)+Y0*Math.cos(FI_PROJ);
    if(iY1==1) mzs[i]=Zsol;
   }
//RichEdit1.append ("PY="+PY[0]+","+PY[1]+","+PY[2]+"\r\n"+ "T_PY="+T_PY[0]+","+T_PY[1]+","+T_PY[2]+"\r\n"+ "P["+i+"]="+P[i]+"\r\n");//!!!
   Time[i]=lagr(3,PY,T_PY,P[i]);
  }

  // -------------------------------------------------------------
  double p,Gamma,R,L,Z_M,Test;
  for (i=0;i<N_SOURCE-1;i++) {
   L=2*S[i];
   p=1.00+A_Z*A_Z*L*L/2.00;
   Test=Math.log(p+Math.sqrt(p*p-1.0))/A_Z;
   Time[i]=Time[i]-Test;
   RichEdit1.append (""+i+"   "+
     Test*1000+ " L=" + L*1000 + " dT=" + Time[i]*1000+"\r\n");
  }
  for(i=0;i<N_SOURCE-1;i++) {
   KOEF_U[index_tek_koef]=Time[i];
   index_tek_koef++;
  }
  Clean();

  for (i=0;i<N_SOURCE-1;i++) {
   DZ1=1/10.;
   j=0;
   Z1d=0.01;
   do { //MN0:;
    //Application->ProcessMessages();
    if (ESCAPE==1) { return; }
    j++;
    Z1=Z1d;
    Y1= Math.sin(FI_PROJ);
    X1=Math.cos(FI_PROJ);
    max=Math.sqrt(X1*X1+Z1*Z1+Y1*Y1);
    Y1=Y1/max; Z1=Z1/max; X1=X1/max;
    X0=XP[i]; Y0=YP[i];Z0=0; Zsol=Z1;
//    Edit1Text=X0; Edit2Text=Y0; Edit3Text=Z0;
//    Edit4Text=X1; Edit5Text=Y1; Edit6Text=Z1;
    IPIX=0;        INEODN=0;
    Start ();
    R1=2*S[i]-Math.sqrt((X0-XP[i])*(X0-XP[i])+(Y0-YP[i])*(Y0-YP[i]));

    if (Math.abs(R1)<0.0001) break;
    //------------
    X0=XP[i]; Y0=YP[i];Z0=0;
    Z1=Z1d;
    Y1=Math.sin(FI_PROJ);
    Z1=Z1+DZ1;
    X1=Math.cos(FI_PROJ);
    max=Math.sqrt(X1*X1+Z1*Z1+Y1*Y1);
    Y1=Y1/max; Z1=Z1/max; X1=X1/max;
//    Edit1Text=(X0); Edit2Text=(Y0); Edit3Text=(Z0);
//    Edit4Text=(X1); Edit5Text=(Y1); Edit6Text=(Z1);
    Zsol=Z1;

    IPIX=0;        INEODN=0;
    Start ();
    //-------------------------
    R2=2*S[i]-Math.sqrt((X0-XP[i])*(X0-XP[i])+(Y0-YP[i])*(Y0-YP[i]));

    if (Math.abs(R2)<0.0001) {
     Z1d=Z1d+DZ1;
     break;
    }

    Z1=Z1d;
    if (R1*R2<0) { DZ1=DZ1/2.0; }
    if (R1*R2>0) { Z1d=Z1+DZ1; }

    if(j>50) break;
    if(Math.abs(R2)>0.0001) continue; //goto MN0;
    else break;
   } while (true);
   //MN1:;
   Clean ();
   if(j>50)   RichEdit1.append ("J>50\r\n");

   Z1=Z1d;
   Y1=Math.sin(FI_PROJ);
   X1=Math.cos(FI_PROJ);
   max=Math.sqrt(X1*X1+Z1*Z1+Y1*Y1);
   Y1=Y1/max; Z1=Z1/max; X1=X1/max;
   X0=XP[i]; Y0=YP[i]; Z0=0;
//   Edit1Text=(X0); Edit2Text=(Y0); Edit3Text=(Z0);
//   Edit4Text=(X1); Edit5Text=(Y1); Edit6Text=(Z1);
   INEODN=0;
   IPIX=1;
   Start ();
   R2=2*S[i]-Math.sqrt((X0-XP[i])*(X0-XP[i])+(Y0-YP[i])*(Y0-YP[i]));

   double L_ray=0;double VMAT;long position;
   index_tek=0;

   for(int matrx=0;matrx<N_MATRIX-1;matrx++) {
    for(int matry=0;matry<N_MATRIX-1;matry++) {
     L_ray=MATRIX[matrx][matry]+L_ray;
     VMAT=MATRIX[matrx][matry];
     //if(CheckBox1->Checked==true) fprintf(OUT_MATRIX,"%f ",MATRIX[matrx][matry]);
     KOEF_A[index_tek][index_tek_a]=MATRIX[matrx][matry];
     index_tek++;
    }
    //if(CheckBox1->Checked==true) fprintf(OUT_MATRIX,"\n");
   }
   index_tek_a++;
   RichEdit1.append ("  " + L_ray+"\r\n");
  }
  //if(CheckBox1->Checked==true) {fclose(OUT_MATRIX);fclose(OUT_MATRIX_U);}
  //delete[] P;delete[] S;delete[] X0P; delete[] XP; delete[] YP; delete[] XS;
  //delete[] YS;delete[]  mzs;delete[]  Time; delete[] FI_SOURCE;   delete[] FI_RESOURCE;
 }

 public void Clean () {
  int i,j;
  //RichEdit1.setText("");
  clearScreen ();
  for(i=0;i<N_MATRIX-1;i++)
  for(j=0;j<N_MATRIX-1;j++)
   MATRIX[i][j]=0;
 }

 public void CleanAll () {
  RichEdit1.setText("");
  Clean ();
 }

 public void Cycle () {
  double R; int i;
  for (i=0;i<=320;i=i+45) {
   R=i;
   Clean();
   ProjectionEdit.setText (""+R);
   BVP();
  }
  gPicture1.setColor(Color.black);
  gPicture1.clearRect (0, 0, Dim1.width, Dim1.height);
  gPicture1.setColor(Color.green);
  gPicture1.drawRect (0, 0, Dim1.width, Dim1.height);
  gPicture1.setColor(Color.white);
  gPicture1.drawString ("-120 ms  discrepancy ",10,15);
  gPicture1.drawString ("120 ms",10,Dim1.height-20);
  for (i=0;i<72;i++) {
   gPicture1.setColor(Color.black);
   gPicture1.clearRect (i*5,120,i*5+4,(int)(1000*KOEF_U[i]+120));
   gPicture1.setColor(Color.white);
   gPicture1.drawRect (i*5,120,i*5+4,(int)(1000*KOEF_U[i]+120));
  }
 }

 /////////////////////////////////////////////////////////////////////////////
 //  2 
 public int DataFromTomo () { //Form2.Button1Click
  float p;
  N=N_MATRIX-1;//Tomography.N_MATRIX-1;
  N_Source=N_SOURCE-1;//Tomography.N_SOURCE-1;
  N_Proj=N_PROJ;//Tomography.N_PROJ;
  N_Proj=8; //???
  if ((N==0) || (N_Source==0) || (N_Proj==0)) {
   RichEdit1.append ("Uncorrect data!\r\n");
   return 0;
  }
  m=N_Proj*N_Source;// 4*13
  n=N*N;
  for (int istrok=0;istrok<m;istrok++) {
   for (int j=0;j<n;j++) {
    A[istrok][j]=KOEF_A[j][istrok];//Tomography.KOEF_A[j][istrok];
   }
  }
  for (int istrok=0;istrok<m;istrok++) {
   u[istrok]=KOEF_U[istrok];//Tomography.KOEF_U[istrok];
  }
  return 1;
 }

 public void normlze (int n) {
  double ss,s;
  s=0;
  for(int i=0;i<n;i++) {
   s=s+p_x[i]*p_x[i];
  }
  s=Math.sqrt(s);
  ss=1/s;
  for (int i=0;i<n;i++) {
   p_x[i]=p_x[i]*ss;
  }
  s_n=s;
  return;
 }

 void atupv (int m,int n) {
  double s;
  for (int i=0;i<n; i++) {
   s=0;
   for (int j=0;j<m; j++) {
    s=s+A[j][i]*p_u[j];
   }
   p_v[i]=p_v[i]+s;
  }
 }

 public void avpu (int m,int n) {
  double s;
  for (int i=0;i<m; i++) {
   s=0;
   for (int j=0;j<n; j++) {
    s=s+A[i][j]*p_v[j];
   }
   p_u[i]=p_u[i]+s;
  }
 }

 public void Solution () { //Form2.Button2Click
  double beta,b1,alfa,rhobar,phibar,a,b,rho,c,s,teta,phi,t1,t2,r,r1,dr;
  itmax=100;
  for (int i=0;i<n;i++) { x[i]=v[i]=0; }
  r1=1000000;
  for (int i=0;i<m;i++) { p_x[i]=u[i]; }
  normlze(m);
  beta=s_n;
  for (int i=0;i<m;i++) { u[i]=p_x[i]; }
  b1=beta;
  for (int i=0;i<m;i++) { p_u[i]=u[i]; }
  for (int i=0;i<n;i++) { p_v[i]=v[i]; }
  atupv(m,n);
  for (int i=0;i<m;i++) { u[i]=p_u[i]; }
  for (int i=0;i<n;i++) { v[i]=p_v[i]; }
  for (int i=0;i<n;i++) { p_x[i]=v[i]; }
  normlze(n);
  alfa=s_n;
  for (int i=0;i<n;i++) { v[i]=p_x[i]; }
  rhobar=alfa;
  phibar=beta;
  for (int i=0;i<n;i++) { w2[i]=v[i]; }
  for (int iter=0;iter<itmax;iter++) {
   a=-alfa;
   for (int i=0;i<m;i++) { u[i]=a*u[i]; }
   for (int i=0;i<m;i++) { p_u[i]=u[i]; }
   for (int i=0;i<n;i++) { p_v[i]=v[i]; }
   avpu(m,n);
   for (int i=0;i<m;i++) { u[i]=p_u[i]; }
   for (int i=0;i<n;i++) { v[i]=p_v[i]; }
   for (int i=0;i<m;i++) { p_x[i]=u[i]; }
   normlze (m);
   beta=s_n;
   for (int i=0;i<m;i++) { u[i]=p_x[i]; }

   b=-beta;
   for (int i=0;i<n;i++) { v[i]=b*v[i]; }
   for (int i=0;i<m;i++) { p_u[i]=u[i]; }
   for (int i=0;i<n;i++) { p_v[i]=v[i]; }
   atupv (m,n);
   for (int i=0;i<m;i++) { u[i]=p_u[i]; }
   for (int i=0;i<n;i++) { v[i]=p_v[i]; }

   for(int i=0;i<n;i++) { p_x[i]=v[i]; }
   normlze (n);
   alfa=s_n;
   for (int i=0;i<n;i++) { v[i]=p_x[i]; }

   rho=Math.sqrt(rhobar*rhobar+beta*beta);
   c=rhobar/rho; s=beta/rho; teta=s*alfa;
   rhobar=-c*alfa; phi=c*phibar; phibar=s*phibar;
   t1=phi/rho; t2= -teta/rho;
   for (int i=0;i<n;i++) { x[i]=t1*w2[i]+x[i]; w2[i]=t2*w2[i]+v[i]; }
   r=phibar/b1;
   //RichEdit1->Lines->Add(IntToStr(iter)+ " "+FloatToStr(phibar)+
   //" "+FloatToStr(r));
   dr=r1-r;
   if(Math.abs(dr)<0.0001) {
    RichEdit1.append ("Process stopped dr % "+ (dr*100)+"\r\n");
    RichEdit1.append ("Iteration = "+ iter+"\r\n");
    break; //goto Metka1;
   }
   r1=r;
  }
  //Metka1:;
  for(int i=0;i<n;i++) {
   RichEdit1.append (""+i+ " "+x[i]+"\r\n");
  }
  //   


  int is=0;
  for (int istrok=0;istrok<N;istrok++) {
   for (int j=0;j<N;j++) {
    SOLUTION[j][istrok]=x[is];
    //if(CheckBox1->Checked==true)        fprintf(out,"%f ",x[is]);
    is++;
   }
   //if(CheckBox1->Checked==true)      fprintf(out,"\n");
  }
  //if(CheckBox1->Checked==true)fclose(out);

//!!!      for (int i1=0; i1<N; i1++) {
//     RichEdit1.append ("\r\n");
//     for (int j1=0; j1<N; j1++) RichEdit1.append (SOLUTION[i1][j1]+" ");
//    }//!!!

  double v,v0,az,SETKA_L;//Radius,
  int N_MATRIX=N+1;
  double[] NetX= new double [NetSize];
  double[] NetY= new double [NetSize];
  double[] DV= new double [NetSize];
  double v_local,v_global,R,x,y,z;//,w,wx,xc,wy,yc,wz,zc;
  double L,R_TEK,pi;//,B_X,C_Y;
  pi=2*Math.asin(1.0);
  //Radius=Tomography.Radius;
//RichEdit1.append("R="+Radius);//!!!
  SETKA_L=Radius;
  //w=Tomography.w;
  //wx=Tomography.wx; wy=Tomography.wy; wz=Tomography.wz;
  //xc=Tomography.xc; yc=Tomography.yc; zc=Tomography.zc;
  v0=V0; az=A_Z;//v0=Tomography.V0; az=Tomography.A_Z;
  R=1/az;
  //B_X=Tomography.B_X; C_Y=Tomography.C_Y;
  for (int i=0;i<100;i++)
  for (int j=0;j<100;j++) {
   Gladim_Veloc[i][j]=0;
  }
  //if(CheckBox1->Checked==true) out=fopen(SaveDialog1->FileName.c_str(),"at");
  for (int i=0;i<N_MATRIX-1;i++) {
   NetX[i]=-SETKA_L+(2*SETKA_L/(double)(N_MATRIX-1))*i+SETKA_L/(double)(N_MATRIX-1);
   NetY[i]=-SETKA_L+(2*SETKA_L/(double)(N_MATRIX-1))*i+SETKA_L/(double)(N_MATRIX-1);
//   RichEdit1.append ("NetX,Y="+NetX[i]+","+NetY[i]+"\r\n");//!!!
  }

  //if(CheckBox1->Checked==true)fprintf(out," correct solution\n");
  //for (int j=0;j<N_MATRIX-1;j++) {
  // x=NetX[j];
   //if(CheckBox1->Checked==true) fprintf(out," %f",x*1000);
  //}
  //if(CheckBox1->Checked==true) fprintf(out,"\n");
  for (int i=0;i<N_MATRIX-1;i++) {
   //if (CheckBox1->Checked==true) fprintf(out,"%f ",NetY[i]*1000);
   for (int j=0;j<N_MATRIX-1;j++) {
    v_local=0;
    DV[j]=0;
    x=NetX[j]; y=NetY[i];
    if(Radius*Radius-y*y<=0) continue; //goto metka;
    L=Math.sqrt(Radius*Radius-y*y);
    R_TEK=Math.sqrt(R*R+L*L);
    z=Math.sqrt(R_TEK*R_TEK-x*x)-R;
    if(z<=0) continue; //goto metka;
    v_local= w*Math.exp(-wx*(xc-x)*(xc-x)-
             wy*(yc-y)*(yc-y)-wz*(zc-z)*(zc-z) );
    DV[j]=v_local;
    //metka:;
    //if(CheckBox1->Checked==true)fprintf(out,"%f ",v_local*1000);
   }
   //if(CheckBox1->Checked==true)fprintf(out,"\n");
  }
  //if (CheckBox1->Checked==true)fprintf(out," reconstruction\n");

  for (int i=0;i<N_MATRIX-1;i++) {
   for (int j=0;j<N_MATRIX-1;j++) {
    V_DEFECT=0;
    v_global=0;
    DV[j]=0;
    x=NetX[j]; y=NetY[i];
    if (Radius*Radius-y*y>0) {// goto metka1;
     L=Math.sqrt(Radius*Radius-y*y);
     R_TEK=Math.sqrt(R*R+L*L);
     z=Math.sqrt(R_TEK*R_TEK-x*x)-R;
     if (z>0) { //goto metka1;
      v_global=v0*(1+az*z);
      V_DEFECT= 1/(SOLUTION[i][j]+1/v_global)-v_global;
      //                    y  x
     }
    }
    //metka1:;
    //v0=v0;
    Veloc[i][j]=V_DEFECT*1000;
    //if(CheckBox1->Checked==true)fprintf(out,"%f ",V_DEFECT*1000);
   }
   //if(CheckBox1->Checked==true)fprintf(out,"\n");
  }
  //if(CheckBox1->Checked==true)fprintf(out," depth of ray, coordinate z\n");

  for (int i=0;i<N_MATRIX-1;i++) {
   for (int j=0;j<N_MATRIX-1;j++) {
    x=NetX[j]; y=NetY[i];
    if (Radius*Radius-y*y<=0) continue; //goto metka2;
    L=Math.sqrt(Radius*Radius-y*y);
    R_TEK=Math.sqrt(R*R+L*L);
    z=Math.sqrt(R_TEK*R_TEK-x*x)-R;
    if(z<=0) { z=0; continue; } //goto metka2;
    //metka2:;
    //if(CheckBox1->Checked==true)fprintf(out,"%f ",z*1000);
   }
   //if(CheckBox1->Checked==true)fprintf(out,"\n");
  }
  //if(CheckBox1->Checked==true)fclose(out);
  return;
 }

 public void MedianFilter () { //Form2.Button4Click
  int imin=0,imin1,imax=0,imax1;
  double SrArif,Rkol;
  double[] Stroka=new double [9];
  double[] Stroka_=new double [9];
  double Smax,Smin;
  int N_MATRIX=N+1;
  for(int i=0;i<100;i++)
  for(int j=0;j<100;j++) { Gladim_Veloc[i][j]=0; }

  for(int i=0;i<N_MATRIX-1;i++) {
   for(int j=0;j<N_MATRIX-1;j++) {
    for (int ij=0;ij<9;ij++) Stroka[ij]=0;
    if ( ((i-1)>=0) && ((j-1)>=0) ) Stroka[0]=Veloc[i-1][j-1];
    if ((i-1)>=0) Stroka[1]=Veloc[i-1][j];
    if ( ((i-1)>=0) && ((j+1)<(N_MATRIX-1)) ) Stroka[2]=Veloc[i-1][j+1];
    if ((j-1)>=0) Stroka[3]=Veloc[i][j-1];
    Stroka[4]=Veloc[i][j];
    if ((j+1)<(N_MATRIX-1)) Stroka[5]=Veloc[i][j+1];
    if ( ((j-1)>=0) && ((i+1)<(N_MATRIX-1)) ) Stroka[6]=Veloc[i+1][j-1];
    if ((i+1)<(N_MATRIX-1)) Stroka[7]=Veloc[i+1][j];
    if ( ((j+1)<(N_MATRIX-1)) && ((i+1)<(N_MATRIX-1)) ) Stroka[8]=Veloc[i+1][j+1];
    Smin=1.0e+10;
    for (int i1=0;i1<9;i1++) {
     if ((Stroka[i1]<Smin) && (Stroka[i1]!=0)) { Smin=Stroka[i1]; imin=i1; }
    }
    Stroka[imin]=0;
    Smin=1.0e+10;
    for(int i1=0;i1<9;i1++) {
     if ((Stroka[i1]<Smin) && (i1!=imin) && (Stroka[i1]!=0)) { Smin=Stroka[i1]; imin1=i1; }
    }
    Smin=1.0e+10; imin=-1;
    for (int i1=0;i1<9;i1++) {
     if ( (Stroka[i1]<Smin) && (Stroka[i1]!=0)) { Smin=Stroka[i1]; imin=i1; }
    }
    if (imin!=-1) Stroka[imin]=0;
    Smax=-1.0e+10;  imax=-1;
    for (int i1=0;i1<9;i1++) {
     if ((Stroka[i1]>Smax) && (Stroka[i1]!=0)) {
      Smax=Stroka[i1]; imax=i1;
     }
    }
    if (imax!=-1) Stroka[imax]=0;
    SrArif=0; Rkol=0;
    for (int i1=0;i1<9;i1++) {
     if (Stroka[i1]==0) continue; //goto vyh;
     else { SrArif=Stroka[i1]+SrArif; Rkol++; }
     //vyh:;
    }
    if (Rkol!=0) { SrArif=SrArif/Rkol; Gladim_Veloc[i][j]=SrArif; }
    if (Rkol==0) Gladim_Veloc[i][j]=Veloc[i][j];
   }
  }
  for(int i=0;i<N_MATRIX-1;i++) {
   for(int j=0;j<N_MATRIX-1;j++) {
    Veloc[i][j]=Gladim_Veloc[i][j];
   }
  }
  /*..   
  if (CheckBox1->Checked==true) {
   out=fopen(SaveDialog1->FileName.c_str(),"at");
   fprintf(out,"  \n");
  }
  for (int i=0;i<N_MATRIX-1;i++) {
   for (int j=0;j<N_MATRIX-1;j++) {
    if (CheckBox1->Checked==true) fprintf(out," %f ",Gladim_Veloc[j][i]);
   }
   if (CheckBox1->Checked==true) fprintf(out,"\n");
  }
  if(CheckBox1->Checked==true)fclose(out);
  */
 }

 public void AverageFilter () { //Form2.Button3Click
  int imin,imin1,imax,imax1;
  double SrArif,Rkol;
  double[] Stroka=new double [9];
  double[] Stroka_=new double [9];
  double Smax,Smin;
  int N_MATRIX=N+1;
  int N_MATRIX_H=N+1;
  //if(CheckBox1->Checked==true)out=fopen(SaveDialog1->FileName.c_str(),"at");
  for(int i=0;i<100;i++)
  for(int j=0;j<100;j++) { Gladim_Veloc[i][j]=0; }
  for (int i=0;i<N_MATRIX_H-1;i++) {
   for (int j=0;j<N_MATRIX-1;j++) {
    for (int ij=0;ij<9;ij++) Stroka[ij]=0;
    if ( ((i-1)>=0) && ((j-1)>=0) ) Stroka[0]=Veloc[i-1][j-1];
    if ((i-1)>=0) Stroka[1]=Veloc[i-1][j];
    if ( ((i-1)>=0) && ((j+1)<(N_MATRIX-1)) ) Stroka[2]=Veloc[i-1][j+1];
    if ((j-1)>=0) Stroka[3]=Veloc[i][j-1];
    Stroka[4]=Veloc[i][j];
    if ((j+1)<(N_MATRIX-1)) Stroka[5]=Veloc[i][j+1];
    if ( ((j-1)>=0) && ((i+1)<(N_MATRIX_H-1)) ) Stroka[6]=Veloc[i+1][j-1];
    if ((i+1)<(N_MATRIX_H-1)) Stroka[7]=Veloc[i+1][j];
    if ( ((j+1)<(N_MATRIX-1)) && ((i+1)<(N_MATRIX_H-1)) ) Stroka[8]=Veloc[i+1][j+1];
    SrArif=0;Rkol=0;
    for (int i1=0;i1<9;i1++) {
     SrArif=Stroka[i1]+SrArif; Rkol++;
    }
    if (Rkol!=0) { SrArif=SrArif/Rkol; Gladim_Veloc[i][j]=SrArif; }
    if (Rkol==0) Gladim_Veloc[i][j]=Veloc[i][j];
   }
  }
  for (int i=0;i<N_MATRIX_H-1;i++) {
   for (int j=0;j<N_MATRIX-1;j++) {
    Veloc[i][j]=Gladim_Veloc[i][j];
   }
  }
/*if (CheckBox1->Checked==true) {
   fprintf(out," velocity smooth-step 2\n");
   for (int i=0;i<N_MATRIX-1;i++) {
    for (int j=0;j<N_MATRIX_H-1;j++) {
     fprintf(out," %f ",Gladim_Veloc[j][i]);
    }
    fprintf(out,"\n");
   }
   fclose(out);
  } */
 }

 public void InterpolationFilter () { //Form2.Button5Click
  double SETKA_L_OUT,SETKA_L;
  int N_MATRIX;
  int N_MATRIX_OUT;
  double[] NetX=new double [NetSize];
  double[] NetY=new double [NetSize];
  double[] NetXR=new double [NetSize];
  double[] NetYR=new double [NetSize];
//  int NGauss;
  double[][] AG=new double [6][6];
  double[] BG=new double [6];
  double[] XG=new double [6];
  double XK_XK1_YL,XK_XK1_YL1,XY;
  SETKA_L=Radius;//Tomography.Radius;
  N_MATRIX=N+1;
//RichEdit1.append ("N="+N+"\r\n");//!!!
  N_MATRIX_OUT=new Integer(PointsInterpolationEdit.getText().trim()).intValue();
  if (N_MATRIX_OUT>100) N_MATRIX_OUT=100;
  if (N_MATRIX_OUT<20) N_MATRIX_OUT=20;
  PointsInterpolationEdit.setText(""+N_MATRIX_OUT);
  SETKA_L_OUT=Radius;//Tomography.Radius;
  for (int i=0; i<100;i++) {
   for (int j=0; j<100;j++) Interp_Veloc[i][j]=0;
  }

  for (int i=0;i<N_MATRIX-1;i++) {
   NetX[i]=-SETKA_L+(2*SETKA_L/(double)(N_MATRIX-1))*i
    +SETKA_L/(double)(N_MATRIX-1);
   NetY[i]=-SETKA_L+(2*SETKA_L/(double)(N_MATRIX-1))*i
    +SETKA_L/(double)(N_MATRIX-1);
//RichEdit1.append ("NetX,Y="+NetX[i]+","+NetY[i]+"\r\n");//!!!
  }
  for (int i=0;i<N_MATRIX_OUT-1;i++) {
   NetXR[i]=-SETKA_L_OUT+(2*SETKA_L_OUT/(double)(N_MATRIX_OUT-1))*i
    +SETKA_L_OUT/(double)(N_MATRIX_OUT-1);
   NetYR[i]=-SETKA_L_OUT+(2*SETKA_L_OUT/(double)(N_MATRIX_OUT-1))*i
    +SETKA_L_OUT/(double)(N_MATRIX_OUT-1);
//RichEdit1.append ("NetXR,YR="+NetXR[i]+","+NetYR[i]+"\r\n");//!!!
  }
//  int count=0;

  for(int i_=0;i_<N_MATRIX_OUT-1;i_++) {
   for (int k_=0;k_<N_MATRIX-2;k_++) {
    if ( (NetX[k_]<=NetXR[i_]) && (NetXR[i_]<=NetX[k_+1]) ) {
     for (int m_=0;m_<N_MATRIX_OUT-1;m_++) {
      for (int l_=0;l_<N_MATRIX-2;l_++) {
       if ((NetY[l_]<=NetYR[m_]) && (NetYR[m_]<=NetY[l_+1]) ) {
        AG[1][1]=NetX[k_];AG[2][1]=NetY[l_];AG[3][1]=NetY[l_]*NetX[k_];AG[4][1]=1;
        AG[1][2]=NetX[k_+1];AG[2][2]=NetY[l_];AG[3][2]=NetY[l_]*NetX[k_+1];AG[4][2]=1;
        AG[1][3]=NetX[k_];AG[2][3]=NetY[l_+1];AG[3][3]=NetY[l_+1]*NetX[k_];AG[4][3]=1;
        AG[1][4]=NetX[k_+1];AG[2][4]=NetY[l_+1];AG[3][4]=NetY[l_+1]*NetX[k_+1];AG[4][4]=1;
        BG[1]=Veloc[k_][l_];
        BG[2]=Veloc[k_+1][l_];
        BG[3]=Veloc[k_][l_+1];
        BG[4]=Veloc[k_+1][l_+1];
        XK_XK1_YL=BG[1]*(NetXR[i_]-NetX[k_+1])/(NetX[k_]-NetX[k_+1])-
                  BG[2]*(NetXR[i_]-NetX[k_])/(NetX[k_]-NetX[k_+1]);
        XK_XK1_YL1=BG[3]*(NetXR[i_]-NetX[k_+1])/(NetX[k_]-NetX[k_+1])-
                   BG[4]*(NetXR[i_]-NetX[k_])/(NetX[k_]-NetX[k_+1]);
        XY=XK_XK1_YL*(NetYR[m_]-NetY[l_+1])/(NetY[l_]-NetY[l_+1])-
                   XK_XK1_YL1*(NetYR[m_]-NetY[l_])/(NetY[l_]-NetY[l_+1]);
        Interp_Veloc[i_][m_]=XY;
//RichEdit1.append ("["+i_+"]["+m_+"]="+Interp_Veloc[i_][m_]+",");//!!!
       }
      }
     }
    }
   }
  }

/*if (CheckBox1->Checked==true) {
   out=fopen(SaveDialog1->FileName.c_str(),"at");
   fprintf(out," interp means\n");
   for (int j=0;j<N_MATRIX_OUT-1;j++) {
    fprintf(out," %f",NetXR[j]*1000);
   }
   fprintf(out,"\n");
   for (int i=0;i<N_MATRIX_OUT-1;i++) {
    fprintf(out,"%f ",NetYR[i]*1000);
    for (int j=0;j<N_MATRIX_OUT-1;j++) {
     fprintf(out,"%f ",Interp_Veloc[i][j]);
    }
    fprintf(out,"\n");
   }
   fclose(out);
  } */
 }

 public void CorrectDecision () { //Form2.Button7Click
  double SETKA_L_OUT,SETKA_L;
  int N_MATRIX;
  int N_MATRIX_OUT;
  double[] NetX=new double [NetSize];
  double[] NetY=new double [NetSize];
  double x,y,z,v0,az; //w,wx,xc,wy,yc,zc,wz,
  double[] NetXR=new double [NetSize];
  double[] NetYR=new double [NetSize];
  double v_local;//,B_X,C_Y;
  double L,R_TEK,R;//,Radius;
//  int NGauss;
  //Radius=Tomography.Radius;
  //w=Tomography.w;
  //wx=Tomography.wx; wy=Tomography.wy; wz=Tomography.wz;
  //xc=Tomography.xc; yc=Tomography.yc; zc=Tomography.zc;
  v0=V0; az=A_Z;//v0=Tomography.V0; az=Tomography.A_Z;
  R=1/az;
  //B_X=Tomography.B_X;
  //C_Y=Tomography.C_Y;
  SETKA_L=Radius;//Tomography.Radius;
  N_MATRIX=N+1;
  N_MATRIX_OUT=new Integer(PointsInterpolationEdit.getText().trim()).intValue();
  if (N_MATRIX_OUT>100) N_MATRIX_OUT=100;
  if (N_MATRIX_OUT<20) N_MATRIX_OUT=20;
  PointsInterpolationEdit.setText(""+N_MATRIX_OUT);
  SETKA_L_OUT=Radius;//Tomography.Radius;
  for(int i=0; i<100;i++) {
   for(int j=0; j<100;j++) Interp_Veloc[i][j]=0;
  }

  for(int i=0;i<N_MATRIX-1;i++) {
   NetX[i]=-SETKA_L+(2*SETKA_L/(double)(N_MATRIX-1))*i
            +SETKA_L/(double)(N_MATRIX-1);
   NetY[i]=-SETKA_L+(2*SETKA_L/(double)(N_MATRIX-1))*i
            +SETKA_L/(double)(N_MATRIX-1);
  }

  for(int i=0;i<N_MATRIX_OUT-1;i++) {
   NetXR[i]=-SETKA_L_OUT+(2*SETKA_L_OUT/(double)(N_MATRIX_OUT-1))*i
    +SETKA_L_OUT/(double)(N_MATRIX_OUT-1);
   NetYR[i]=-SETKA_L_OUT+(2*SETKA_L_OUT/(double)(N_MATRIX_OUT-1))*i
    +SETKA_L_OUT/(double)(N_MATRIX_OUT-1);
  }

//  int count=0;
  for (int i_=0;i_<N_MATRIX_OUT-1;i_++) {
   for (int m_=0;m_<N_MATRIX_OUT-1;m_++) {
    v_local=0;
    x=NetXR[i_]; y=NetYR[m_];
    if (!(Radius*Radius-y*y<=0)) { // goto metka;
     L=Math.sqrt(Radius*Radius-y*y);
     R_TEK=Math.sqrt(R*R+L*L);
     z=Math.sqrt(R_TEK*R_TEK-x*x)-R;
     if (!(z<=0)) { // goto metka;
      v_local= w*Math.exp(-wx*(xc-x)*(xc-x)-
               wy*(yc-y)*(yc-y)-wz*(zc-z)*(zc-z) );
     }
    }
    //metka:;
    Interp_Veloc[m_][i_]=v_local*1000;
   }
  }
 }

 public void BeforeGraph2 () {
  centr=new Integer (PointsInterpolationEdit.getText().trim()).intValue();
  centr=(centr-2)/2;

  pos=new Integer (Gain.getSelectedItem().trim()).intValue(); //TrackBar1->Position;
  interval=new Integer (Scale.getSelectedItem().trim()).intValue(); //TrackBar2->Position;
  dest=Destination.getSelectedItem().trim();
  if (dest=="In left panel") {
   gPicture1.setColor(Color.black);
   gPicture1.fillRect (0,0,Dim1.width, Dim1.height);
   gPicture1.setColor(Color.white);
  }
  else {
   gPicture2.setColor(Color.black);
   gPicture2.fillRect (0,0,Dim2.width, Dim2.height);
   gPicture2.setColor(Color.white);
  }
 }

 public void  AfterGraph2 () {
  if (dest=="In left panel") {
   gPicture1.setColor(Color.green);//Bitmap1->Canvas->Pen->Color=clAqua;
   pic1X=0; pic1Y=(centr-1)*interval; //Bitmap1->Canvas->MoveTo(0,(centr-1)*interval);
   LineTo1 (Dim1.width,(centr-1)*interval); //Bitmap1->Canvas->LineTo(Image1->Width,(centr-1)*interval);
   pic1X=centr*interval; pic1Y=0; //Bitmap1->Canvas->MoveTo(centr*interval,0);
   LineTo1 (centr*interval,Dim1.height); //Bitmap1->Canvas->LineTo(centr*interval,Image1->Height);
  }
  else {
   gPicture2.setColor(Color.green);
   pic2X=0; pic2Y=(centr-1)*interval;
   LineTo2 (Dim2.width,(centr-1)*interval);
   pic2X=centr*interval; pic2Y=0;
   LineTo2 (centr*interval,Dim2.height);
  }
 }

 public void  MapImage () {
  //!!!Bitmap1->Canvas->Pen->Width=interval;
  pic1X=0; pic1Y=0; //Bitmap1->Canvas->MoveTo(0,0);
  pic2X=0; pic2Y=0;
  if (dest=="In left panel")
   gPicture1.setColor(Color.white); //Bitmap1->Canvas->Brush->Color=clWhite;
  else
   gPicture2.setColor(Color.white);
  int width=interval*3/4;//Bitmap1->Canvas->Pen->Width=interval*3/4;
  //Bitmap1->Canvas->MoveTo(0,0);
  double max=Interp_Veloc[0][0],min=max;
  for (int i=0;i<100;i++)
  for (int j=0;j<100;j++) {
   double p=pos*Interp_Veloc[j][i];
   if (p>max) max=p;
   else if (p<min) min=p;
  }
  double coef=255./(max-min);

  for (int i=0;i<100;i++) {
   //pic1X=i*interval; pic1Y=0; //Bitmap1->Canvas->MoveTo(i*interval,0);
   for (int j=0;j<100;j++) {
    double p=pos*Interp_Veloc[j][i];
    int col=(int)((p-min)*coef);
    if (dest=="In left panel") {
     gPicture1.setColor(new Color(col, col, col)); //Bitmap1->Canvas->Pen->Color=RGB(col,col,col);
     gPicture1.fillRect (i*interval,j*interval,i*interval+width,(j+1)*interval);
     //LineTo1 (i*interval,j*interval); //Bitmap1->Canvas->LineTo(i*interval,j*interval);
    }
    else {
     gPicture2.setColor(new Color(col, col, col));
     gPicture2.fillRect (i*interval,j*interval,i*interval+width,(j+1)*interval);
    }
   }
  }
 }

 public void  LineImage () {
  //Bitmap1->Canvas->Pen->Width=1;
  //Bitmap1->Canvas->MoveTo(0,0);
  if (dest=="In left panel")
   gPicture1.setColor(Color.white); //Bitmap1->Canvas->Brush->Color=clWhite;
  else
   gPicture2.setColor(Color.white);
  //Bitmap1->Canvas->Pen->Width=2;
  pic1X=0; pic1Y=0; //Bitmap1->Canvas->MoveTo(0,0);
  pic2X=0; pic2Y=0;
  for (int i=0;i<100;i++) {
   pic1X=i*interval; pic1Y=0; //Bitmap1->Canvas->MoveTo(i*interval,0);
   pic2X=i*interval; pic2Y=0;
   for (int j=0;j<100;j++) {
    double fl=pos*Interp_Veloc[j][i]/3;
    int col=(int)fl;
    if (dest=="In left panel") {
     gPicture1.setColor(Color.white); //Bitmap1->Canvas->Pen->Color=clWhite;
     LineTo1 (i*interval+col,j*interval); //Bitmap1->Canvas->LineTo(i*interval+col,j*interval);
    }
    else {
     gPicture2.setColor(Color.white); //Bitmap1->Canvas->Pen->Color=clWhite;
     LineTo2 (i*interval+col,j*interval); //Bitmap1->Canvas->LineTo(i*interval+col,j*interval);
    }
   }
  }
 }

 public boolean action (Event evt, Object obj) {
  Dim1 = pPicture1.getSize();
  Dim2 = pPicture2.getSize();
  if(evt.target instanceof Button) {
   if(evt.target.equals(BVPButton)) {
    Parameters();
    BVP();
   }
   else if(evt.target.equals(ParametersButton)) {
    Parameters();
   }
   else if(evt.target.equals(CycleButton)) {
    Cycle();
   }
   else if(evt.target.equals(CleanButton)) {
    CleanAll ();
   }
   // 2:
   else if(evt.target.equals(SolutionButton)) {
    if (DataFromTomo ()==1) Solution ();
   }
   else if(evt.target.equals(MedianButton)) {
    MedianFilter();
   }
   else if(evt.target.equals(AverageButton)) {
    AverageFilter();
   }
   else if(evt.target.equals(InterpolationButton)) {
    InterpolationFilter();
   }
   else if(evt.target.equals(CorrectButton)) {
    CorrectDecision();
   }
   else if(evt.target.equals(MapImageButton)) {
    BeforeGraph2 ();
    MapImage ();
    AfterGraph2 ();
   }
   else if(evt.target.equals(LineImageButton)) {
    BeforeGraph2 ();
    LineImage ();
    AfterGraph2 ();
   }
   else { return false; }
   return true;
  }
  else {
   return false;
  }
 }

}

