import java.applet.*;
import java.awt.*;
import java.util.*;

public class Profile2 extends Applet {

  Panel pLeftPanel,pRightPanel,pPicture1,pPicture2;
  Button Button1,Button2,Button3;
  Label Label1,Label2,Label3,Label4,Label5,Label6,Label7,Label8,Label9,Label10;
  TextField Edit1,Edit2,Edit3,Edit4,Edit5,Edit6,Edit7,Edit8,Edit9,Edit10;
  TextArea RichEdit1;

  double X0,Y0,Z0,T,Fi,Beta,Gamma,X1,Y1,Z1,PI,ZMAX,A_Z,B_X,C_Y,H,H0;
  double L,R,tx0,ty0,tz0,Z_M,Rad,Test,p;
  int count;

  public String getAppletInfo() {
   return "Profile2 Java Applet. Kislenko N.P., kis@ngasu.nsk.su";
  }

 public void init() {
  setLayout(new GridLayout(1,2,2,2));
  pLeftPanel = new Panel();
  pLeftPanel.setBackground(Color.white);
  pLeftPanel.setForeground(Color.black);
  pRightPanel = new Panel();
  add(pLeftPanel);
  add(pRightPanel);
  pPicture1  = new Panel();
  pPicture1.setBackground(Color.white);
  pPicture1.setForeground(Color.red);
  pPicture2  = new Panel();
  pPicture2.setBackground(Color.white);
  pPicture2.setForeground(Color.red);
  pRightPanel.setLayout(new GridLayout(2,1,2,2));
  pRightPanel.add(pPicture1);
  pRightPanel.add(pPicture2);

  pLeftPanel.setLayout (new GridLayout (12,2,2,2));
  Button1=new Button ("Start");
  Button2=new Button ("Normalize");
  Button3=new Button ("Clear");
  Label1=new Label ("X (0<X<4)");        Edit1=new TextField ("0",10);
  Label2=new Label ("Y (-0.5<Y<0.5)");        Edit2=new TextField ("0",10);
  Label3=new Label ("Z (0<Z<1)");        Edit3=new TextField ("0",10);
  Label4=new Label ("a");    Edit4=new TextField ("1",10);
  Label5=new Label ("b");   Edit5=new TextField ("0",10);
  Label6=new Label ("c (a*a+b*b+c*c=1)");   Edit6=new TextField ("1",10);
  Label7=new Label ("Az (0.5<Az<2)");       Edit7=new TextField ("0.5",10);
  Label8=new Label ("H (0.001<H<1)");        Edit8=new TextField ("0.001",10);
  Label9=new Label ("Ax (0<Ax<0.2)");       Edit9=new TextField ("0",10);
  Label10=new Label ("Ay (0<Ay<0.5)");      Edit10=new TextField ("0",10);
  RichEdit1=new TextArea ("",5,50);

  pLeftPanel.add (Label1);  pLeftPanel.add (Edit1);
  pLeftPanel.add (Label2);  pLeftPanel.add (Edit2);
  pLeftPanel.add (Label3);  pLeftPanel.add (Edit3);
  pLeftPanel.add (Label9);  pLeftPanel.add (Edit9);
  pLeftPanel.add (Label10); pLeftPanel.add (Edit10);
  pLeftPanel.add (Label7);  pLeftPanel.add (Edit7);
  pLeftPanel.add (Label4);  pLeftPanel.add (Edit4);
  pLeftPanel.add (Label5);  pLeftPanel.add (Edit5);
  pLeftPanel.add (Label6);  pLeftPanel.add (Edit6);
  pLeftPanel.add (Label8);  pLeftPanel.add (Edit8);
  pLeftPanel.add (Button2); pLeftPanel.add (Button1);
  pLeftPanel.add (Button3); pLeftPanel.add (RichEdit1);

  repaint();
 }

 public void clearScreen () {
  Graphics gPicture1,gPicture2;
  gPicture1 = pPicture1.getGraphics();
  gPicture2 = pPicture2.getGraphics();
  Dimension Dim1 = pPicture1.size();
  gPicture1.clipRect(0, 0, Dim1.width , Dim1.height);
  gPicture1.clearRect(0, 0, Dim1.width - 1, Dim1.height - 1);
  gPicture1.drawRect(0, 0, Dim1.width - 1, Dim1.height - 1);

  gPicture1.setColor(Color.black);
  gPicture1.drawString ("X",Dim1.width-10,10);
  gPicture1.drawString ("Z",1,Dim1.height-1);

  gPicture2.clipRect(0, 0, Dim1.width, Dim1.height);
  gPicture2.clearRect(0, 0, Dim1.width - 1, Dim1.height - 1);
  gPicture2.drawRect(0, 0, Dim1.width - 1, Dim1.height - 1);

  gPicture2.setColor(Color.black);
  gPicture2.drawString ("X",Dim1.width-10,10);
  gPicture2.drawString ("Y",1,Dim1.height-1);
 }

 public void paint(Graphics g) {
  clearScreen ();
 }

 public void Normalize () {
  double X1,Y1,Z1,xx,yy,zz;
  X1=new Double(Edit4.getText().trim()).doubleValue();
  Y1=new Double(Edit5.getText().trim()).doubleValue();
  Z1=new Double(Edit6.getText().trim()).doubleValue();
  H0=new Double(Edit8.getText().trim()).doubleValue();
  // 
  xx=X1/Math.sqrt(X1*X1+Y1*Y1+Z1*Z1);
  yy=Y1/Math.sqrt(X1*X1+Y1*Y1+Z1*Z1);
  zz=Z1/Math.sqrt(X1*X1+Y1*Y1+Z1*Z1);
  zz=Math.sqrt(1.0-xx*xx-yy*yy);
  Edit4.setText (""+xx);
  Edit5.setText (""+yy);
  Edit6.setText (""+zz);
 }

 public void Runge () {
  Graphics gPtr1,gPtr2;
  gPtr1 = pPicture1.getGraphics();
  gPtr2 = pPicture2.getGraphics();
  //Dimension Dim1 = pPicture1.size(); //!!!
  //int width= Dim1.width-2, height=Dim1.height-2;

  double PI,V,Fi,X2,Y2,Z2;
  double XS0,YS0,ZS0,XS1,YS1,ZS1,XS2,YS2,ZS2,H1,DX,DY,DZ,DX1,DY1,DZ1;
  double Q1X1,Q1Y1,Q1Z1,Q1X2,Q1Y2,Q1Z2,
         Q2X1,Q2Y1,Q2Z1,Q2X2,Q2Y2,Q2Z2,
         Q3X1,Q3Y1,Q3Z1,Q3X2,Q3Y2,Q3Z2,
         Q4X1,Q4Y1,Q4Z1,Q4X2,Q4Y2,Q4Z2;
  double  dlnV_dX,dlnV_dY,dlnV_dZ;
  long iX0,iY0,iZ0,startX0,startY0,startZ0;

  ZMAX=0;
  PI=2.0*Math.asin(1.0);

  startX0=Math.round(100.0*X0);
  startZ0=Math.round(100.0*Z0);
  startY0=Math.round(100.0*Y0);

  T=0;

  for (count=0;count<1200000;count++) {
   H=H0;
   if (Z0<0.005) { H=H/10.0; }
   dlnV_dX=0.;
   dlnV_dY=0.;
   dlnV_dZ=A_Z/(1.0+A_Z*Z0);

   dlnV_dX=B_X/(1.0+A_Z*Z0+B_X*X0+C_Y*Y0);
   dlnV_dY=C_Y/(1.0+A_Z*Z0+B_X*X0+C_Y*Y0);
   dlnV_dZ=A_Z/(1.0+A_Z*Z0+B_X*X0+C_Y*Y0);

   X2=X1*(dlnV_dY*Y1+dlnV_dZ*Z1+X1*dlnV_dX)-dlnV_dX;
   Y2=Y1*(dlnV_dX*X1+dlnV_dZ*Z1+Y1*dlnV_dY)-dlnV_dY;
   Z2=Z1*(dlnV_dX*X1+dlnV_dY*Y1+Z1*dlnV_dZ)-dlnV_dZ;
   Q1X1=H*X1; Q1Y1=H*Y1; Q1Z1=H*Z1;
   Q1X2=H*X2; Q1Y2=H*Y2; Q1Z2=H*Z2;

   XS0=X0+Q1X1/2.0; YS0=Y0+Q1Y1/2.0; ZS0=Z0+Q1Z1/2.0;
   XS1=X1+Q1X2/2.0; YS1=Y1+Q1Y2/2.0; ZS1=Z1+Q1Z2/2.0;
   X2=XS1*(dlnV_dY*YS1+dlnV_dZ*ZS1+XS1*dlnV_dX)-dlnV_dX;
   Y2=YS1*(dlnV_dX*XS1+dlnV_dZ*ZS1+YS1*dlnV_dY)-dlnV_dY;
   Z2=ZS1*(dlnV_dX*XS1+dlnV_dY*YS1+ZS1*dlnV_dZ)-dlnV_dZ;
   Q2X1=H*XS1; Q2Y1=H*YS1; Q2Z1=H*ZS1;
   Q2X2=H*X2; Q2Y2=H*Y2; Q2Z2=H*Z2;

   XS0=X0+Q2X1/2.0; YS0=Y0+Q2Y1/2.0; ZS0=Z0+Q2Z1/2.0;
   XS1=X1+Q2X2/2.0; YS1=Y1+Q2Y2/2.0; ZS1=Z1+Q2Z2/2.0;

   X2=XS1*(dlnV_dY*YS1+dlnV_dZ*ZS1+XS1*dlnV_dX)-dlnV_dX;
   Y2=YS1*(dlnV_dX*XS1+dlnV_dZ*ZS1+YS1*dlnV_dY)-dlnV_dY;
   Z2=ZS1*(dlnV_dX*XS1+dlnV_dY*YS1+ZS1*dlnV_dZ)-dlnV_dZ;
   Q3X1=H*XS1; Q3Y1=H*YS1; Q3Z1=H*ZS1;
   Q3X2=H*X2; Q3Y2=H*Y2; Q3Z2=H*Z2;

   XS0=X0+Q3X1; YS0=Y0+Q3Y1; ZS0=Z0+Q3Z1;
   XS1=X1+Q3X2; YS1=Y1+Q3Y2; ZS1=Z1+Q3Z2;

   X2=XS1*(dlnV_dY*YS1+dlnV_dZ*ZS1+XS1*dlnV_dX)-dlnV_dX;
   Y2=YS1*(dlnV_dX*XS1+dlnV_dZ*ZS1+YS1*dlnV_dY)-dlnV_dY;
   Z2=ZS1*(dlnV_dX*XS1+dlnV_dY*YS1+ZS1*dlnV_dZ)-dlnV_dZ;
   Q4X1=H*XS1; Q4Y1=H*YS1; Q4Z1=H*ZS1; Q4X2=H*X2; Q4Y2=H*Y2; Q4Z2=H*Z2;

   DX=(Q1X1+2.0*(Q2X1+Q3X1)+Q4X1)/6.0;
   DY=(Q1Y1+2.0*(Q2Y1+Q3Y1)+Q4Y1)/6.0;
   DZ=(Q1Z1+2.0*(Q2Z1+Q3Z1)+Q4Z1)/6.0;

   DX1=(Q1X2+2.0*(Q2X2+Q3X2)+Q4X2)/6.0;
   DY1=(Q1Y2+2.0*(Q2Y2+Q3Y2)+Q4Y2)/6.0;
   DZ1=(Q1Z2+2.0*(Q2Z2+Q3Z2)+Q4Z2)/6.0;

   X0=X0+DX;
   Y0=Y0+DY;
   Z0=Z0+DZ;
   V=1.0+A_Z*(Z0+DZ/2.0)+B_X*(X0+DX/2.0)+C_Y*(Y0+DY/2.0);
   T=T+Math.sqrt(DX*DX+DY*DY+DZ*DZ)/V;

   if (Z0>ZMAX) { ZMAX=Z0; }
   X1=X1+DX1;
   Y1=Y1+DY1;
   Z1=Z1+DZ1;

   if (Z0<0.0) { break; }

   iX0=Math.round(100.0*X0);
   iZ0=Math.round(100.0*Z0);
   iY0=Math.round(100.0*Y0);
   gPtr1.drawLine ((int)startX0,(int)startZ0,(int)iX0,(int)iZ0);
   gPtr2.drawLine ((int)startX0,(int)startY0,(int)iX0,(int)iY0+120);
   startX0=iX0; startZ0=iZ0; startY0=iY0+120; //!!!
 //   Bitmap1->Canvas->LineTo(iX0,iZ0);
 //   Bitmap2->Canvas->LineTo(iX0,iY0+120);

/*   if ( (count/100)*100==count) {
    Image1->Picture->Assign(Bitmap1);
    Image2->Picture->Assign(Bitmap2);
   } */
  RichEdit1.setText("step "+count);//!!!
  }
 }

 public void Method() {
  X0=new Double(Edit1.getText().trim()).doubleValue();
  Y0=new Double(Edit2.getText().trim()).doubleValue();
  Z0=new Double(Edit3.getText().trim()).doubleValue();
  X1=new Double(Edit4.getText().trim()).doubleValue();
  Y1=new Double(Edit5.getText().trim()).doubleValue();
  Z1=new Double(Edit6.getText().trim()).doubleValue();
  A_Z=new Double(Edit7.getText().trim()).doubleValue();
  B_X=new Double(Edit9.getText().trim()).doubleValue();
  C_Y=new Double(Edit10.getText().trim()).doubleValue();
  Gamma=Math.acos(Z1);
  R=1.0/(A_Z*Math.sin(Gamma));
  L=2.0*Math.sqrt(R*R-1.0/(A_Z*A_Z));
  Z_M=R-1/A_Z;
  p=1.00+A_Z*A_Z*L*L/2.00;
  Test=Math.log(p+Math.sqrt(p*p-1.0))/A_Z;
  count=0;
  Runge();

  Rad=Math.sqrt(X0*X0+Y0*Y0);
  RichEdit1.setText("");
  RichEdit1.appendText ("L= "+L+"\r\n");
  RichEdit1.appendText ("Z_M= "+Z_M+"\r\n");
  RichEdit1.appendText ("Test= "+Test+"\r\n");
  RichEdit1.appendText ("X "+X0+"\r\n");
  RichEdit1.appendText ("Y "+Y0+"\r\n");
  RichEdit1.appendText ("Z "+Z0+"\r\n");
  RichEdit1.appendText ("Rad "+Rad+"\r\n");
  RichEdit1.appendText ("T "+T+"\r\n");
  RichEdit1.appendText ("ZMAX "+ZMAX+"\r\n");
  RichEdit1.appendText ("Count "+count+"\r\n");
 }

 public boolean action (Event evt, Object obj) {
  if(evt.target instanceof Button) {
   if(evt.target.equals(Button1)) {
    Normalize();
    Method();
   }
   else if(evt.target.equals(Button2)) {
    Normalize();
   }
   else if(evt.target.equals(Button3)) {
    RichEdit1.setText("");
    clearScreen ();
   }
   else { return false; }
   return true;
  }
  else {
   return false;
  }
 }

}

